#!/usr/bin/perl

###########################################################################
# HITLOG - Administration Functions Script File               Version 1.1 #
# Written by Patrick Dingle                     dimension@cgiworkshop.com #
# Released February 7, 1999         A Product of Dimension's CGI Workshop #
# ----------------------------------------------------------------------- #
# Dimension's CGI Workshop:         http://www.cgiworkshop.com/dimension/ #
# ----------------------------------------------------------------------- #
# Copyright (c) 1998-1999 Patrick Dingle, All Rights Reserved.  This      #
# program may not be modified or redistributed in any way without the     #
# expressed consent of Patrick Dingle, with the exception of the marked   #
# portions.  This program is provided AS IS.  Neither Patrick Dingle nor  #
# Dimension's CGI Workshop is responsible for any damaged caused,         #
# directly or indirectly, by the usage of this program. This notice must  #
# remain in place under any circumstances.                                #
###########################################################################

###########################################################################
# *** NO GLOBAL CONSTANT VARIABLES NEED TO BE MODIFIED IN THIS SCRIPT *** #
###########################################################################


print "Content-type:text/html\n\n";

### PARSE FORM ###
read(STDIN, $buffer, $ENV{'CONTENT_LENGTH'});
@pairs = split(/&/, $buffer);
foreach $pair (@pairs)
{
    ($name, $value) = split(/=/, $pair);
    $value =~ tr/+/ /;
    $value =~ s/%([a-fA-F0-9][a-fA-F0-9])/pack("C", hex($1))/eg;
    $value =~ s/~!/ ~!/g;    $FORM{$name} = $value;
}

### READ HIDDEN VARIABLES FROM SUBMITTED FORM ###
$logfile = $FORM{logfile};
$enc = $FORM{realpassword};
$inputpass = $FORM{pass};
$len = length($enc);$newlen = ($len - 1) / 2;$in = "";for ($temp = $len; $temp >= 1; $temp--){$str[$temp] = chop($enc);$ascii[$temp] = ord $str[$temp];}$subtr = $str[1];for ($temp = 2; $temp <= $len; $temp = $temp + 2){$toadd = chr ($ascii[$temp] - $subtr);$in = $in . $toadd;}$enc = $in;
$len = length($enc);$newlen = ($len - 1) / 2;$in = "";for ($temp = $len; $temp >= 1; $temp--){$str[$temp] = chop($enc);$ascii[$temp] = ord $str[$temp];}$subtr = $str[1];for ($temp = 2; $temp <= $len; $temp = $temp + 2){$toadd = chr ($ascii[$temp] - $subtr);$in = $in . $toadd;}
$realpassword = $in;

foreach $key (keys(%FORM))
{
	chop($key);
	$c = chop($key);
	if ($c eq '.') { $q = $key; }
}

open (FILE, "$logfile");
@infile = <FILE>;
close (FILE);

if ($q eq "Specific") { $d = $FORM{spday1}; $m = $FORM{spmonth1}; $y = $FORM{spyear1}; }
elsif ($q eq "onorbefore") { $d = $FORM{spday2}; $m = $FORM{spmonth2}; $y = $FORM{spyear2}; }
elsif ($q eq "onorafter") { $d = $FORM{spday3}; $m = $FORM{spmonth3}; $y = $FORM{spyear3}; }
$comb = $y * 10000 + $m * 100 + $d;

if ($realpassword ne $inputpass) {
	print "<html><head><title>You entered an invalid password</title></head><body bgcolor=black text=white link=yellow vlink=yellow alink=cyan>\n";
	print "<center><table width=620 border=0 bgcolor=black><tr><td bgcolor=black width=100%>\n";
	print "<center><font color=cyan size=6 face=\"arial\"><b>Invalid Password</b></font></center><hr size=5>\n";
	print "<font color=white size=2 face=\"arial\"><b>Sorry, the password you have entered is not valid.  Please go back, recheck your password, and try again.</b></font>\n";
	print "<hr size=5><font color=white size=1 face=\"arial\"><center>HitLog 1.1 - Copyright (C) 1998-1999 <a href=\"http://www.cgiworkshop.com/dimension\">Dimension's CGI Workshop</a>, all rights reserved.</center></font></td></tr></table></center></body></html>\n";
}
else {
	if ($q eq "lhits" || $q eq "fhits") {
		$count = 0;
		foreach $lineofdata (@infile) {
			$count++;
		}
		open (FILE, ">$logfile");
		if ($q eq "fhits") {
			for ($x = $FORM{fhits}; $x <= $count; $x++) {
				print FILE "$infile[$x]";
			}
		}
		if ($q eq "lhits") {
			$count--;
			for ($x = 1; $x <= ($count-$FORM{lhits}); $x++) {
				print FILE "$infile[$x]";
			}
		}
		close (FILE);
	}
	elsif ($q eq "Specific" || $q eq "onorbefore" || $q eq "onorafter") {
		open (FILE, ">$logfile");
		foreach $lineofdata (@infile) {
			($mon,$mday,$year,$hour,$min,$sec,$documenturi,$remoteaddr,$httpreferer,$remotehost) = split(/\|/, $lineofdata);
			$filecomb = $year * 10000 + $mon * 100 + $mday;
			if ($q eq "Specific") {
				if ($comb ne $filecomb) { print FILE "$lineofdata"; }
			}
			elsif ($q eq "onorbefore") {
				if ($comb < $filecomb) { print FILE "$lineofdata"; }
			}
			elsif ($q eq "onorafter") {
				if ($comb > $filecomb) { print FILE "$lineofdata"; }
			}
		}
		close (FILE);
	}
	elsif ($q eq "entire") {
		open (FILE, ">$logfile");
		close (FILE);
	}

	print "<html><head><title>Log File Changes Complete</title></head><body bgcolor=black text=white link=yellow vlink=yellow alink=cyan>\n";
	print "<center><table width=620 border=0 bgcolor=black><tr><td bgcolor=black width=100%>\n";
	print "<center><font color=cyan size=6 face=\"arial\"><b>Changes Complete</b></font></center><hr size=5>\n";
	print "<font color=white size=2 face=\"arial\"><b>The changes to the log file that you requested have been completed.  <a href=\"hitlog.pl?stats\">Back to the statistics page</a>.</b></font>\n";
	print "<hr size=5><font color=white size=1 face=\"arial\"><center>HitLog 1.1 - Copyright (c) 1998-1999 <a href=\"http://www.cgiworkshop.com/dimension\">Dimension's CGI Workshop</a>, all rights reserved.</center></font></td></tr></table></center></body></html>\n";
}

